#! ruby -Ks
  # the sample for UserForm
require "exlap"
uf_str, mdl_str = DATA.read.split(/\n##\n/)
filename = "mcr11.xls"
Exlap.new(filename) do |wb|
  uf = wb.macro_add(uf_str, 3, "SampleForm")  # add UserForm component
  uf.Designer.Controls.Add("Forms.TextBox.1")  # add TextBox
  uf.Designer.Controls.Add("Forms.ListBox.1")  # add ListBox
  uf.Designer.Controls.Add("Forms.CommandButton.1")  # add CommandButton
  wb.macro_add(mdl_str)  # add standard module component
  wb.app.obj.MacroOptions('Macro'=>"TestSampleForm", 'ShortcutKey'=>"U")
  wb.save
end

__END__
' UserForm module
Private Sub CommandButton1_Click()
    Range("A1").Value = Me.TextBox1.Value
    Range("B1").Value = Me.ListBox1.Value
    Unload Me
End Sub

Private Sub UserForm_Initialize()
    With TextBox1
        .AutoSize = True
    End With
    With ListBox1
        .AddItem "cat"
        .AddItem "dog"
        .AddItem "fox"
    End With
    With CommandButton1
        .Caption = "Finish"
    End With
End Sub

##
' standard module
Sub TestSampleForm()
    SampleForm.Show
End Sub
